/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Jump type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Jump{}

// Jump struct for Jump
type Jump struct {
	Trigger JumpTrigger `json:"trigger"`
	Target JumpTarget `json:"target"`
	// Required if target is `block`
	BlockId *string `json:"block_id,omitempty"`
	// Required if trigger is `button`
	ButtonId *string `json:"button_id,omitempty"`
	Condition *Condition `json:"condition,omitempty"`
	Integrations *Integrations `json:"integrations,omitempty"`
	Writers []Writer `json:"writers,omitempty"`
}

// NewJump instantiates a new Jump object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJump(trigger JumpTrigger, target JumpTarget) *Jump {
	this := Jump{}
	this.Trigger = trigger
	this.Target = target
	return &this
}

// NewJumpWithDefaults instantiates a new Jump object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJumpWithDefaults() *Jump {
	this := Jump{}
	return &this
}

// GetTrigger returns the Trigger field value
func (o *Jump) GetTrigger() JumpTrigger {
	if o == nil {
		var ret JumpTrigger
		return ret
	}

	return o.Trigger
}

// GetTriggerOk returns a tuple with the Trigger field value
// and a boolean to check if the value has been set.
func (o *Jump) GetTriggerOk() (*JumpTrigger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Trigger, true
}

// SetTrigger sets field value
func (o *Jump) SetTrigger(v JumpTrigger) {
	o.Trigger = v
}

// GetTarget returns the Target field value
func (o *Jump) GetTarget() JumpTarget {
	if o == nil {
		var ret JumpTarget
		return ret
	}

	return o.Target
}

// GetTargetOk returns a tuple with the Target field value
// and a boolean to check if the value has been set.
func (o *Jump) GetTargetOk() (*JumpTarget, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Target, true
}

// SetTarget sets field value
func (o *Jump) SetTarget(v JumpTarget) {
	o.Target = v
}

// GetBlockId returns the BlockId field value if set, zero value otherwise.
func (o *Jump) GetBlockId() string {
	if o == nil || IsNil(o.BlockId) {
		var ret string
		return ret
	}
	return *o.BlockId
}

// GetBlockIdOk returns a tuple with the BlockId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Jump) GetBlockIdOk() (*string, bool) {
	if o == nil || IsNil(o.BlockId) {
		return nil, false
	}
	return o.BlockId, true
}

// HasBlockId returns a boolean if a field has been set.
func (o *Jump) HasBlockId() bool {
	if o != nil && !IsNil(o.BlockId) {
		return true
	}

	return false
}

// SetBlockId gets a reference to the given string and assigns it to the BlockId field.
func (o *Jump) SetBlockId(v string) {
	o.BlockId = &v
}

// GetButtonId returns the ButtonId field value if set, zero value otherwise.
func (o *Jump) GetButtonId() string {
	if o == nil || IsNil(o.ButtonId) {
		var ret string
		return ret
	}
	return *o.ButtonId
}

// GetButtonIdOk returns a tuple with the ButtonId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Jump) GetButtonIdOk() (*string, bool) {
	if o == nil || IsNil(o.ButtonId) {
		return nil, false
	}
	return o.ButtonId, true
}

// HasButtonId returns a boolean if a field has been set.
func (o *Jump) HasButtonId() bool {
	if o != nil && !IsNil(o.ButtonId) {
		return true
	}

	return false
}

// SetButtonId gets a reference to the given string and assigns it to the ButtonId field.
func (o *Jump) SetButtonId(v string) {
	o.ButtonId = &v
}

// GetCondition returns the Condition field value if set, zero value otherwise.
func (o *Jump) GetCondition() Condition {
	if o == nil || IsNil(o.Condition) {
		var ret Condition
		return ret
	}
	return *o.Condition
}

// GetConditionOk returns a tuple with the Condition field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Jump) GetConditionOk() (*Condition, bool) {
	if o == nil || IsNil(o.Condition) {
		return nil, false
	}
	return o.Condition, true
}

// HasCondition returns a boolean if a field has been set.
func (o *Jump) HasCondition() bool {
	if o != nil && !IsNil(o.Condition) {
		return true
	}

	return false
}

// SetCondition gets a reference to the given Condition and assigns it to the Condition field.
func (o *Jump) SetCondition(v Condition) {
	o.Condition = &v
}

// GetIntegrations returns the Integrations field value if set, zero value otherwise.
func (o *Jump) GetIntegrations() Integrations {
	if o == nil || IsNil(o.Integrations) {
		var ret Integrations
		return ret
	}
	return *o.Integrations
}

// GetIntegrationsOk returns a tuple with the Integrations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Jump) GetIntegrationsOk() (*Integrations, bool) {
	if o == nil || IsNil(o.Integrations) {
		return nil, false
	}
	return o.Integrations, true
}

// HasIntegrations returns a boolean if a field has been set.
func (o *Jump) HasIntegrations() bool {
	if o != nil && !IsNil(o.Integrations) {
		return true
	}

	return false
}

// SetIntegrations gets a reference to the given Integrations and assigns it to the Integrations field.
func (o *Jump) SetIntegrations(v Integrations) {
	o.Integrations = &v
}

// GetWriters returns the Writers field value if set, zero value otherwise.
func (o *Jump) GetWriters() []Writer {
	if o == nil || IsNil(o.Writers) {
		var ret []Writer
		return ret
	}
	return o.Writers
}

// GetWritersOk returns a tuple with the Writers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Jump) GetWritersOk() ([]Writer, bool) {
	if o == nil || IsNil(o.Writers) {
		return nil, false
	}
	return o.Writers, true
}

// HasWriters returns a boolean if a field has been set.
func (o *Jump) HasWriters() bool {
	if o != nil && !IsNil(o.Writers) {
		return true
	}

	return false
}

// SetWriters gets a reference to the given []Writer and assigns it to the Writers field.
func (o *Jump) SetWriters(v []Writer) {
	o.Writers = v
}

func (o Jump) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Jump) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["trigger"] = o.Trigger
	toSerialize["target"] = o.Target
	if !IsNil(o.BlockId) {
		toSerialize["block_id"] = o.BlockId
	}
	if !IsNil(o.ButtonId) {
		toSerialize["button_id"] = o.ButtonId
	}
	if !IsNil(o.Condition) {
		toSerialize["condition"] = o.Condition
	}
	if !IsNil(o.Integrations) {
		toSerialize["integrations"] = o.Integrations
	}
	if !IsNil(o.Writers) {
		toSerialize["writers"] = o.Writers
	}
	return toSerialize, nil
}

type NullableJump struct {
	value *Jump
	isSet bool
}

func (v NullableJump) Get() *Jump {
	return v.value
}

func (v *NullableJump) Set(val *Jump) {
	v.value = val
	v.isSet = true
}

func (v NullableJump) IsSet() bool {
	return v.isSet
}

func (v *NullableJump) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJump(val *Jump) *NullableJump {
	return &NullableJump{value: val, isSet: true}
}

func (v NullableJump) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJump) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


